//<#!@READ-ONLY-SECTION-START@!#>
/*!
 * \class cfm_vulcanoapp
 * \brief Intel(R) CoFluent(TM) Studio - Intel Corporation
 * \details Simulation model of VulcanoApp generated by C++ Generator for SystemC/TLM2
 */

#ifndef COFS_MODEL_VULCANOAPP
#define COFS_MODEL_VULCANOAPP

#include "cfm_vulcanoapp_global.h"
#include "cfm_vulcanoapp_global_types.h"
#include "cofluent.h"

#include "cfm_consumer.h"
#include "cfm_producer_1.h"
//<#!@READ-ONLY-SECTION-END@!#>
//Start of 'VulcanoApp includes' algorithm generated code

//End of 'VulcanoApp includes' algorithm generated code
//<#!@READ-ONLY-SECTION-START@!#>

///    \defgroup dxgVulcanoApp Function VulcanoApp
//@{
///        \page dxpVulcanoApp
//@{
///    \brief VulcanoApp function model.
class cfm_vulcanoapp: public cf_core::cf_application {
public:
	/// relations typedef
	typedef cf_core::cf_message_queue<cf_core::cf_payload_int> mq_changedQ_t;

	/// constructor
	cfm_vulcanoapp(sc_core::sc_module_name name);

	/// destructor
	virtual ~cfm_vulcanoapp(void);
	virtual void cb_before_elaboration(void);

	void cb_end_of_elaboration(void);
	void cb_end_of_simulation(void);

public:
	/// \name functions
	//@{
	cfm_consumer* Consumer;
	cfm_producer_1* Producer_1;
	//@}

protected:
	/// initialize attributes
	void cb_init_attributes(void);
	/// initialize definitions
	void cb_init_local_vars(void);

public:
	/// \name relations
	//@{
	mq_changedQ_t mq_changedQ;
	//@}

	/// \name user-defined local declarations
	//<#!@READ-ONLY-SECTION-END@!#>
	//Start of 'VulcanoApp local declarations' algorithm generated code

	//End of 'VulcanoApp local declarations' algorithm generated code
	//<#!@READ-ONLY-SECTION-START@!#>

};

//@}
//@}
#endif // COFS_MODEL_VULCANOAPP

//<#!@READ-ONLY-SECTION-END@!#>